/* Copyright (c) 2001 AT&T Corp.  All rights reserved.

This software may only be used by you under license from AT&T Corp. 
("AT&T").  A copy of AT&T's Source Code Agreement is available at 
AT&T's Internet website having the URL 

http://www.research.att.com/sw/tools/graphviz/license/

If you received this software without first entering into a license 
with AT&T, you have an infringing copy of this software and cannot 
use it without violating AT&T's intellectual property rights. */

#include "Geometry.h"

namespace PathPlan {
	typedef vector<Segment> SegmentV;
	typedef vector<Line> LineV;

	struct InvalidBoundary {};
	struct EndpointNotInPolygon { 
		bool which; 
		EndpointNotInPolygon(bool which) : which(which) {}
	};
	/* find shortest euclidean path within a simple polygon */
	void Shortest(const Line &boundary, Segment endpoints, Line &out);

	/* fit a spline to an input polyline, without touching barrier segments */
	bool Route(const SegmentV &barriers, const Line &inputRoute,
		Segment endSlopes,Line &out);

	/* utility function to convert from a set of polygonal obstacles to barriers */
	void PolyBarriers(const LineV &polygons, SegmentV &out);
}
