#include <iostream>
struct GeomParseError {
	string val;
	GeomParseError(string val = string()) : val(val) {}
};
struct BadSplineValue {
	int val;
	BadSplineValue(int val) : val(val) {}
};
inline istream & operator>>(istream &is, Coord &read) {
	is >> read.x;
	char c;
	is >> c;
	if(c!=',') {
		GeomParseError xep;
		xep.val.assign(1,c);
		throw xep;
	}
	is >> read.y;
	return is;
}
inline istream & operator>>(istream &is,Line &read) {
	read.clear();
	char ch;
	if(!is.eof()) {
		is.get(ch);
		if(ch=='b') {
			int level;
			is >> level;
			switch(level) {
			case 1:
			case 3:
				read.degree = level;
				break;
			default:
				throw BadSplineValue(level);
			}
		}
		else {
			read.degree = 1;
			is.unget();
		}
	}
	while(!is.eof()) {
		char ch;
		is.get(ch);
		if(ch==';')
			break;
		else
			is.unget();
		Coord c;
		is >> c;
		read.push_back(c);
	}
	return is;
}
inline istream & operator>>(istream &is,Lines &read) {
	read.clear();
	while(!is.eof()) {
		read.push_back(Line());
		is >> read.back();
	}
	return is;
}
inline ostream & operator <<(ostream &os,const Coord &write) {
	os.flags(os.flags()|ios::fixed);
	os << write.x << ',' << write.y;
	return os;
}
inline ostream & operator <<(ostream &os,const Line &write) {
	os << 'b' << write.degree;
	for(Line::const_iterator ci = write.begin(); ci!=write.end(); ++ci)
		os << ' ' << *ci;
	return os;
}
inline ostream & operator <<(ostream &os,const Lines &write) {
	for(Lines::const_iterator li = write.begin(); li!=write.end(); ++li)
		os << *li << ';';
	return os;
}
