/* Copyright (c) 2001 AT&T Corp.  All rights reserved.

This software may only be used by you under license from AT&T Corp. 
("AT&T").  A copy of AT&T's Source Code Agreement is available at 
AT&T's Internet website having the URL 

http://www.research.att.com/sw/tools/graphviz/license/

If you received this software without first entering into a license 
with AT&T, you have an infringing copy of this software and cannot 
use it without violating AT&T's intellectual property rights. */

template<typename Type>
class invalid {
    Type d;
    bool v;

    public:
    invalid(Type d) : d(d), v(true) {}
    invalid() : v(false) {}
    operator Type() const {
		assert(v);
		return d;
	}
	Type operator=(Type n) {
		d = n;
		v = true;
		return d;
	}
	Type operator+(Type n) {
		assert(v);
		return d+n;
	}
	Type operator-(Type n) {
		assert(v);
		return d-n;
	}
	Type operator*(Type n) {
		assert(v);
		return d*n;
	}
	Type operator/(Type n) {
		assert(v);
		return d/n;
	}
	Type operator+=(Type n) {
		*this = *this+n;
		return d;
	}
	Type operator-=(Type n) {
		*this = *this-n;
		return d;
	}
	Type operator*=(Type n) {
		*this = *this * n;
		return d;
	}
	Type operator/=(Type n) {
		*this = *this/n;
		return d;
	}
};

