/* Copyright (c) 2001 AT&T Corp.  All rights reserved.

This software may only be used by you under license from AT&T Corp. 
("AT&T").  A copy of AT&T's Source Code Agreement is available at 
AT&T's Internet website having the URL 

http://www.research.att.com/sw/tools/graphviz/license/

If you received this software without first entering into a license 
with AT&T, you have an infringing copy of this software and cannot 
use it without violating AT&T's intellectual property rights. */

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_MALLOC_H
#include <malloc.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

void incr_begin_session(char *id);
void incr_end_session(char *id);
void incr_open_view(char *id);
void incr_close_view(char *id);
void incr_lock(char *id);
void incr_unlock(char *id);
void incr_segue(char *id);
void incr_mod_view(char *id);
void incr_ins_node(char *view,char *id);
void incr_mod_node(char *view,char *id);
void incr_del_node(char *view,char *id);
void incr_ins_edge(char *view,char *id, char *tail, char *head);
void incr_mod_edge(char *view,char *id);
void incr_del_edge(char *view,char *id);

void incr_view_obj(char *vid, char *objid);
void incr_unview_obj(char *vid, char *objid);

void incr_abort(int code);
void incr_reset_attrs();
void incr_append_attr(char *name, char *value);
char *incr_get_attr(char *name);
void incr_error(int code, char *msg);
void incr_lexeof();

#ifdef __cplusplus
}
struct ParseError {};
struct IncrError {};
#endif


#define IF_ERR_UNKNOWN			0
#define IF_ERR_ALREADY_OPEN		1
#define IF_ERR_NOT_OPEN			2
#define IF_ERR_NAME_MISMATCH	3
#define IF_ERR_SYNTAX			4
#define IF_ERR_DUPLICATE_ID		5
#define IF_ERR_NOT_IMPLEMENTED	6
#define IF_ERR_OBJECT_DOESNT_EXIST 7
#define IF_MAX_ERR				8

#define IF_MAXATTR				128

#ifdef offsetof
#undef offsetof
#endif
#define offsetof(typ,fld)  ((int)(&(((typ*)0)->fld)))
#ifndef streq
#define streq(s,t) (!strcmp(s,t))
#endif
